// @generated by protobuf-ts 2.9.1
// @generated from protobuf file "monitor.proto" (package "listener", syntax proto3)
// tslint:disable
import type { RpcTransport } from "@protobuf-ts/runtime-rpc";
import type { ServiceInfo } from "@protobuf-ts/runtime-rpc";
import { Listener } from "./monitor";
import type { ServicesResponse } from "./monitor";
import type { Empty } from "./google/protobuf/empty";
import type { UnaryCall } from "@protobuf-ts/runtime-rpc";
import { stackIntercept } from "@protobuf-ts/runtime-rpc";
import type { MonitorResponse } from "./monitor";
import type { MonitorRequest } from "./monitor";
import type { ServerStreamingCall } from "@protobuf-ts/runtime-rpc";
import type { RpcOptions } from "@protobuf-ts/runtime-rpc";
/**
 * @generated from protobuf service listener.Listener
 */
export interface IListenerClient {
    /**
     * @generated from protobuf rpc: Monitor(listener.MonitorRequest) returns (stream listener.MonitorResponse);
     */
    monitor(input: MonitorRequest, options?: RpcOptions): ServerStreamingCall<MonitorRequest, MonitorResponse>;
    /**
     * @generated from protobuf rpc: ListServices(google.protobuf.Empty) returns (listener.ServicesResponse);
     */
    listServices(input: Empty, options?: RpcOptions): UnaryCall<Empty, ServicesResponse>;
    /**
     * @generated from protobuf rpc: CurrentStatus(listener.MonitorRequest) returns (listener.MonitorResponse);
     */
    currentStatus(input: MonitorRequest, options?: RpcOptions): UnaryCall<MonitorRequest, MonitorResponse>;
}
/**
 * @generated from protobuf service listener.Listener
 */
export class ListenerClient implements IListenerClient, ServiceInfo {
    typeName = Listener.typeName;
    methods = Listener.methods;
    options = Listener.options;
    constructor(private readonly _transport: RpcTransport) {
    }
    /**
     * @generated from protobuf rpc: Monitor(listener.MonitorRequest) returns (stream listener.MonitorResponse);
     */
    monitor(input: MonitorRequest, options?: RpcOptions): ServerStreamingCall<MonitorRequest, MonitorResponse> {
        const method = this.methods[0], opt = this._transport.mergeOptions(options);
        return stackIntercept<MonitorRequest, MonitorResponse>("serverStreaming", this._transport, method, opt, input);
    }
    /**
     * @generated from protobuf rpc: ListServices(google.protobuf.Empty) returns (listener.ServicesResponse);
     */
    listServices(input: Empty, options?: RpcOptions): UnaryCall<Empty, ServicesResponse> {
        const method = this.methods[1], opt = this._transport.mergeOptions(options);
        return stackIntercept<Empty, ServicesResponse>("unary", this._transport, method, opt, input);
    }
    /**
     * @generated from protobuf rpc: CurrentStatus(listener.MonitorRequest) returns (listener.MonitorResponse);
     */
    currentStatus(input: MonitorRequest, options?: RpcOptions): UnaryCall<MonitorRequest, MonitorResponse> {
        const method = this.methods[2], opt = this._transport.mergeOptions(options);
        return stackIntercept<MonitorRequest, MonitorResponse>("unary", this._transport, method, opt, input);
    }
}
